// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-filter.go
package expr

import (
	"fmt"
	"io"

	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
)

//-------- map term

func newFilterTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 2),
		Position: scan.PosInfix,
		Priority: scan.PriIterOp,
		EvalFunc: evalFilter,
	}
}

func evalFilter(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	var leftValue, rightValue any
	var it kern.Iterator
	var item any
	var ok bool

	if err = opTerm.CheckOperands(); err != nil {
		return
	}

	if leftValue, err = opTerm.Children[0].Compute(ctx); err != nil {
		return
	}

	if it, ok = leftValue.(kern.Iterator); !ok {
		if it, err = NewIterator(ctx, leftValue, nil); err != nil {
			return nil, fmt.Errorf("left operand of FILTER must be an iterable data-source; got %s", kern.TypeName(leftValue))
		}
	}

	values := kern.NewListA()
	for item, err = it.Next(); err == nil; item, err = it.Next() {
		ctx.SetVar("_", item)
		ctx.SetVar("__", it.Index())
		ctx.SetVar("_#", it.Count())
		if rightValue, err = opTerm.Children[1].Compute(ctx); err == nil {
			if success, valid := kern.ToBool(rightValue); valid {
				if success {
					values.AppendItem(item)
				}
			} else {
				err = fmt.Errorf("filter expression must return a boolean or a castable to boolean, got %v [%T]", rightValue, rightValue)
			}
		}
		ctx.DeleteVar("_#")
		ctx.DeleteVar("__")
		ctx.DeleteVar("_")
		if err != nil {
			break
		}
	}
	if err == io.EOF {
		err = nil
	}
	v = values
	return
}

// init
func init() {
	scan.RegisterTermConstructor(scan.SymKwFilter, newFilterTerm)
}
